<script setup lang="ts">
import { useMemberStore } from '@/stores/member'
import { usePromotionStore } from '@/stores/promotion'
import { useReceiptStore } from '@/stores/receipt'
import PromotionDialog from '@/views/Promotion/PromotionDialog.vue'
import { ref } from 'vue'
import ErrorDialog from './ErrorDialog.vue'

const receiptStore = useReceiptStore()
const memberStore = useMemberStore()
const promotionStore = usePromotionStore()
const memStore = useMemberStore()
const point = ref()
const dialogUseMemberPoint = ref(false)

const required = (v: string | boolean | number) => {
  if (typeof v === 'string') {
    return /^\d+$/.test(v) || 'Field must be a non-negative integer'
  } else if (typeof v === 'boolean') {
    return v === true || 'Field is required'
  } else if (typeof v === 'number') {
    return v >= 0 || 'Value must be greater than or equal to 0'
  }
  return true
}

function closeUseMemberPoint() {
  dialogUseMemberPoint.value = false
}

async function useMemberPointConfirm(value: string) {
  const point = parseFloat(value)
  console.log(memberStore.editedMember.point)
  if (point > memberStore.editedMember.point) {
    alert('Point is not enough')
    dialogUseMemberPoint.value = false
  } else {
    memberStore.editedMember.point -= point
    updatePointDiscount(value)
    receiptStore.calReceipt()
    dialogUseMemberPoint.value = false
  }
}

const updatePointDiscount = (value: string) => {
  receiptStore.receipt!.memberDiscount = parseFloat(value)
}

function openPromotionDialog() {
  promotionStore.promotionDialog = true
}
</script>

<template>
  <v-container class="font">
    <v-row no-gutters>
      <v-col cols="6" class="mb-3">Total :</v-col>
      <v-col cols="6" class="mb-3">{{ receiptStore.receipt?.total + ' ฿' }}</v-col>

      <v-col cols="6" class="mb-3">Member Point :</v-col>
      <v-col cols="6" class="mb-3">{{ memberStore.editedMember?.point + ' ★' }}</v-col>

      <v-col cols="6" class="mb-3">Member Discount :</v-col>
      <v-col cols="6" class="mb-3">{{ '- ' + receiptStore.receipt?.memberDiscount + ' ฿' }}</v-col>

      <v-col cols="6" class="mb-3">Promotion Discount :</v-col>
      <v-col cols="6" class="mb-3">{{
        '- ' + receiptStore.receipt?.promotionDiscount + ' ฿'
      }}</v-col>

      <v-col cols="6" class="mb-5">Total Net :</v-col>
      <v-col cols="6" class="mb-5">{{ receiptStore.receipt?.totalNet + ' ฿' }}</v-col>
      <v-row justify="center">
        <v-col cols="4" class="mb-2">
          <v-btn
            :disabled="receiptStore.receipt.memberId == 0"
            rounded="xl"
            color="primary"
            width="200"
            @click="dialogUseMemberPoint = true"
            >Use Member Point</v-btn
          >
        </v-col>
        <v-col cols="4" class="mb-2">
          <v-btn rounded="xl" color="primary" @click="openPromotionDialog" width="230"
            >Use Promotion</v-btn
          >
        </v-col>
        <v-col cols="4" class="mb-2">
          <v-btn rounded="xl" color="primary" width="230" :to="{ name: 'mem' }"
            >Register Member</v-btn
          >
        </v-col>
      </v-row>
    </v-row>
  </v-container>
  <v-dialog v-model="dialogUseMemberPoint" max-width="300px">
    <v-card>
      <v-card-title class="font ma-4" style="text-align: center">Use Point </v-card-title>
      <v-text-field
        v-model="point"
        :rules="[required]"
        clearable
        label="Point"
        variant="outlined"
        class="mr-7 ml-7"
        type="number"
      ></v-text-field>
      <v-card-actions>
        <v-btn
          color="red"
          variant="flat"
          style="width: 100px; height: 40px"
          class="ml-5 mr-9 mb-5"
          rounded="xl"
          @click="closeUseMemberPoint"
          >Cancel</v-btn
        >
        <v-btn
          color="success"
          variant="flat"
          style="width: 100px; height: 40px"
          rounded="xl"
          class="mb-5"
          :disabled="point < 0"
          @click="useMemberPointConfirm(point)"
          >OK</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
* {
  font-family: 'Kanit';
}

.input-cash {
  width: 150px;
  height: 56px;
  background: transparent;
  border: none;
  outline: none;
  border: 2px solid rgba(8, 8, 8, 0.2);
  border-radius: 10px;
  padding: 20px 45px 20px 20px;
}

.flex-col {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  height: 100%;
}
</style>
